Debian Bug report logs - #497489
[checkbashisms] Please detect the use of [^] instead of [!]

version graph

Package: devscripts; Maintainer for devscripts is Devscripts Devel Team <devscripts-devel@lists.alioth.debian.org>; Source for devscripts is src:devscripts.

Reported by: Raphael Geissert <atomo64@gmail.com>

Date: Tue, 2 Sep 2008 03:03:01 UTC

Severity: wishlist

Tags: patch

Found in version devscripts/2.10.35

Fixed in version devscripts/2.10.65

Done: James Vega <jamessan@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. Full text and rfc822 format available.

Message #3 received at submit@bugs.debian.org (full text, mbox):

From: Raphael Geissert <atomo64@gmail.com>
To: submit@bugs.debian.org
Subject: checkbashisms: please detect the usage of [^] in, at least, case/esac constructs
Date: Mon, 1 Sep 2008 22:00:15 -0500
[Message part 1 (text/plain, inline)]
Package: devscripts
Version: 2.10.35
Severity: wishlist
User: devscripts@packages.debian.org
Usertags: checkbashisms

$ cat /tmp/t
#!/bin/sh

case "moo" in
    [^f]oo)
        echo hey
    ;;
    [!f]oo)
        echo moo
    ;;
esac

$ for sh in {po,{d,b}a,{m,pd,}k,z,busybox\ }sh; do echo "$sh: $($sh /tmp/t)"; 
done
posh: moo
dash: moo
bash: hey
mksh: moo
pdksh: moo
ksh: hey
zsh: hey
busybox sh: hey

Fun:
$ cat /tmp/t2
#!/bin/sh

case "foo" in
    [^f]oo)
        echo hey
    ;;
    [!f]oo)
        echo moo
    ;;
esac

$ for sh in {po,{d,b}a,{m,pd,}k,z,busybox\ }sh; do echo "$sh: $($sh /tmp/t2)"; 
done
posh: hey
dash: hey
bash:
mksh: hey
pdksh: hey
ksh:
zsh:
busybox sh:

Cheers,
-- 
Atomo64 - Raphael

Please avoid sending me Word, PowerPoint or Excel attachments.
See http://www.gnu.org/philosophy/no-word-attachments.html
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Fri, 17 Oct 2008 22:21:02 GMT) Full text and rfc822 format available.

Message #6 received at 497489@bugs.debian.org (full text, mbox):

From: Raphael Geissert <atomo64@gmail.com>
To: 497489@bugs.debian.org
Cc: control@bugs.debian.org
Subject: checkbashisms: please detect the usage of [^] in, at least, case/esac constructs
Date: Fri, 17 Oct 2008 17:19:06 -0500
[Message part 1 (text/plain, inline)]
retitle 497489 please detect the usage of [^] instead of [!]
thanks

Just noticed that my example was probably not very clear, so here's another 
example that I hope is easier to understand.

$ file="$(mktemp)"
$ cat > $file << FOO
#!/bin/sh

# This script expects [^] NOT to match, IOW: bash's behaviour

case "\$1" in
    [^m]oo)
        echo not moo
        exit
    ;;
esac

echo got moo
FOO
$ for sh in {po,{d,b}a,{m,pd,}k,z,busybox\ }sh; do echo "$sh: $($sh $file 
foo)"; done
posh: got moo
dash: got moo
bash: not moo
mksh: got moo
pdksh: got moo
ksh: not moo
zsh: not moo
busybox sh: not moo

And

$ for sh in {po,{d,b}a,{m,pd,}k,z,busybox\ }sh; do echo "$sh: $($sh $file 
moo)"; done
posh: not moo
dash: not moo
bash: got moo
mksh: not moo
pdksh: not moo
ksh: got moo
zsh: got moo
busybox sh: got moo

Cheers,
-- 
Raphael Geissert - Debian Maintainer
www.debian.org - get.debian.net
[signature.asc (application/pgp-signature, inline)]

Changed Bug title to `please detect the usage of [^] instead of [!]' from `checkbashisms: please detect the usage of [^] in, at least, case/esac constructs'. Request was from Raphael Geissert <atomo64@gmail.com> to control@bugs.debian.org. (Fri, 17 Oct 2008 22:21:03 GMT) Full text and rfc822 format available.

Changed Bug title to `[checkbashisms] Please detect the use of [^] instead of [!]' from `please detect the usage of [^] instead of [!]'. Request was from Adam D. Barratt <adam@adam-barratt.org.uk> to control@bugs.debian.org. (Tue, 21 Oct 2008 19:06:05 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Fri, 21 May 2010 02:21:03 GMT) Full text and rfc822 format available.

Message #13 received at 497489@bugs.debian.org (full text, mbox):

From: Raphael Geissert <geissert@debian.org>
To: 535368@bugs.debian.org, 497489@bugs.debian.org, 572006@bugs.debian.org, 531327@bugs.debian.org
Cc: control@bugs.debian.org
Subject: checkbashisms: multiple patches
Date: Thu, 20 May 2010 21:19:07 -0500
[Message part 1 (text/plain, inline)]
tag 535368 patch
tag 497489 patch
tag 572006 patch
tag 531327 patch
thanks

Hi,

Attached mbox includes patches for the corresponding bug reports among other 
changes (bug fixes, new checks.)

The changes were tested against a regressions testsuite I wrote and the 
/bin/sh scripts of the entire archive (sid/{main,contrib,non-free}), 
debian/rules included.

Cheers,
-- 
Raphael Geissert - Debian Developer
www.debian.org - get.debian.net
[checkbashisms.mbox (application/mbox, attachment)]

Added tag(s) patch. Request was from Raphael Geissert <geissert@debian.org> to control@bugs.debian.org. (Fri, 21 May 2010 02:21:11 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Tue, 25 May 2010 05:15:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to James Vega <jamessan@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Tue, 25 May 2010 05:15:03 GMT) Full text and rfc822 format available.

Message #20 received at 497489@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: Raphael Geissert <geissert@debian.org>, 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Tue, 25 May 2010 01:10:58 -0400
[Message part 1 (text/plain, inline)]
On Thu, May 20, 2010 at 09:19:07PM -0500, Raphael Geissert wrote:
> Attached mbox includes patches for the corresponding bug reports among other 
> changes (bug fixes, new checks.)

Thanks for the patches.  I've applied all of them, with one slight
change to the one below.

diff --git a/scripts/checkbashisms.pl b/scripts/checkbashisms.pl
index 02698af..1eeda6a 100755
--- a/scripts/checkbashisms.pl
+++ b/scripts/checkbashisms.pl
@@ -198,7 +198,7 @@ foreach my $filename (@ARGV) {
 		$_ = $1 if $1;
 	    } 
 
-	    last if m%^(export )?SHELL\s*:?=\s*(/bin/)?bash\s*%;
+	    last if m%^\s*(override|export)?\s*SHELL\s*:?=\s*(/bin/)?bash\s*%;

Require a space after override/export -- (override |export )

-- 
James
GPG Key: 1024D/61326D40 2003-09-02 James Vega <jamessan@debian.org>
[signature.asc (application/pgp-signature, inline)]

Added tag(s) pending. Request was from James Vega <jamessan@debian.org> to control@bugs.debian.org. (Tue, 25 May 2010 05:15:11 GMT) Full text and rfc822 format available.

Message sent on to Raphael Geissert <atomo64@gmail.com>:
Bug#497489. (Tue, 25 May 2010 05:15:13 GMT) Full text and rfc822 format available.

Message #25 received at 497489-submitter@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: 497489-submitter@bugs.debian.org
Subject: Bug#497489 marked as pending
Date: Tue, 25 May 2010 05:13:18 +0000
tag 497489 pending
thanks

Hello,

Bug #497489 reported by you has been fixed in the Git repository. You can
see the changelog below, and you can check the diff of the fix at:

    http://git.debian.org/?p=devscripts/devscripts.git;a=commitdiff;h=be54022

---
commit be540223084c1e62f1626ab18da08729bb9411ee
Author: James Vega <jamessan@debian.org>
Date:   Tue May 25 01:11:13 2010 -0400

    Add changelog entries for Raphael's patches.
    
    Signed-off-by: James Vega <jamessan@debian.org>

diff --git a/debian/changelog b/debian/changelog
index c19a3b1..66a342a 100644
--- a/debian/changelog
+++ b/debian/changelog
@@ -8,6 +8,25 @@ devscripts (2.10.65) UNRELEASED; urgency=low
   * Remove svk from Recommends, it is no longer in the archive. (Closes:
     #581224)
 
+  [ Raphael Geissert ]
+  * checkbashisms:
+    + Makefile handling:
+      - Simplify make variables as shell variables.  (Closes: #535368)
+      - Convert all $$ to $.
+      - Recognize SHELL setting in Makefile when being set as an override.
+      - Ignore make's '-' for ignore errors.
+      - Fix some false positives due to target names.
+    + Detect incorrect use of ^ instead of ! for negation in pattern matching
+      collections.  (Closes: #497489)
+    + Detect use of {post,pre}{increment,decrement} in arithmetic expansion.
+      (Closes: #572006)
+    + Detect use of Bash's “printf -v var ...” or the %b and %q format
+      specifiers.
+    + Detect use of the Bash's “coproc” keyword.
+    + Detect use of Bash's “;;&” and ”;&” operators.
+    + Add support for handling line continuations.  (Closes: #531327)
+    + Fix a false positive with file redirection.
+
  -- Martin Zobel-Helas <zobel@debian.org>  Tue, 11 May 2010 20:48:16 +0200
 
 devscripts (2.10.64) unstable; urgency=low




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Tue, 25 May 2010 15:18:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Geissert <geissert@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Tue, 25 May 2010 15:18:07 GMT) Full text and rfc822 format available.

Message #30 received at 497489@bugs.debian.org (full text, mbox):

From: Raphael Geissert <geissert@debian.org>
To: 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Tue, 25 May 2010 10:14:23 -0500
Hi James,

On 25 May 2010 00:10, James Vega <jamessan@debian.org> wrote:
> On Thu, May 20, 2010 at 09:19:07PM -0500, Raphael Geissert wrote:
>> Attached mbox includes patches for the corresponding bug reports among other
>> changes (bug fixes, new checks.)
>
> Thanks for the patches.  I've applied all of them, with one slight
> change to the one below.

Thanks!

I couldn't find another commit fixing the bug you found, so I'm going
to to include it in my next batch of changes (which I'm testing
against the archive as I type.)

P.S. sorry for the noise caused by CCing the multiple bugs. Should
have used -quiet.

Cheers,
-- 
Raphael Geissert - Debian Developer
www.debian.org - get.debian.net




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Tue, 25 May 2010 15:30:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to James Vega <jamessan@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Tue, 25 May 2010 15:30:10 GMT) Full text and rfc822 format available.

Message #35 received at 497489@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: Raphael Geissert <geissert@debian.org>, 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Tue, 25 May 2010 11:27:55 -0400
On Tue, May 25, 2010 at 11:14 AM, Raphael Geissert <geissert@debian.org> wrote:
> Hi James,
>
> On 25 May 2010 00:10, James Vega <jamessan@debian.org> wrote:
>> On Thu, May 20, 2010 at 09:19:07PM -0500, Raphael Geissert wrote:
>>> Attached mbox includes patches for the corresponding bug reports among other
>>> changes (bug fixes, new checks.)
>>
>> Thanks for the patches.  I've applied all of them, with one slight
>> change to the one below.
>
> Thanks!
>
> I couldn't find another commit fixing the bug you found, so I'm going
> to to include it in my next batch of changes (which I'm testing
> against the archive as I type.)

I included it in the commit that added changelog entries for your
changes -- be54022.

-- 
James
GPG Key: 1024D/61326D40 2003-09-02 James Vega <jamessan@debian.org>




Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Tue, 25 May 2010 15:48:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Raphael Geissert <geissert@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Tue, 25 May 2010 15:48:06 GMT) Full text and rfc822 format available.

Message #40 received at 497489@bugs.debian.org (full text, mbox):

From: Raphael Geissert <geissert@debian.org>
To: 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Tue, 25 May 2010 10:45:47 -0500
[Message part 1 (text/plain, inline)]
On 25 May 2010 10:27, James Vega <jamessan@debian.org> wrote:
> On Tue, May 25, 2010 at 11:14 AM, Raphael Geissert <geissert@debian.org> wrote:
>> I couldn't find another commit fixing the bug you found, so I'm going
>> to to include it in my next batch of changes (which I'm testing
>> against the archive as I type.)
>
> I included it in the commit that added changelog entries for your
> changes -- be54022.

Right, didn't see it. (Could use \s instead, though :)

If you allow me, attached is another mbox with two more patches. The
archive-wide check is not done yet and I've only verified some of the
results, but there doesn't seem to be any (major at least)
bug/regression introduced by those changes. Some false positives are
now visible because some portions of code are now actually checked,
but that's it.

They are both required to make checkbashisms actually find bashisms in
complex scripts such as "configure" scripts.

Cheers,
-- 
Raphael Geissert - Debian Developer
www.debian.org - get.debian.net
[checkbashisms-2nd.mbox (application/octet-stream, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Tue, 25 May 2010 22:57:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to James Vega <jamessan@debian.org>:
Extra info received and forwarded to list. Copy sent to Devscripts Devel Team <pkg-devscripts@teams.debian.net>. (Tue, 25 May 2010 22:57:03 GMT) Full text and rfc822 format available.

Message #45 received at 497489@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: Raphael Geissert <geissert@debian.org>, 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Tue, 25 May 2010 18:55:53 -0400
[Message part 1 (text/plain, inline)]
On Tue, May 25, 2010 at 10:45:47AM -0500, Raphael Geissert wrote:
> On 25 May 2010 10:27, James Vega <jamessan@debian.org> wrote:
> > On Tue, May 25, 2010 at 11:14 AM, Raphael Geissert <geissert@debian.org> wrote:
> >> I couldn't find another commit fixing the bug you found, so I'm going
> >> to to include it in my next batch of changes (which I'm testing
> >> against the archive as I type.)
> >
> > I included it in the commit that added changelog entries for your
> > changes -- be54022.
> 
> Right, didn't see it. (Could use \s instead, though :)

Good point.  I'll make that change.  I noticed via one of your other
patches what looks to be a bad check for file redirection.

  qr'(<\&|>\&)\s*((-|\d+)[^\s;|)}`&\\\\]|[^-\d\s]+)' =>
                                 q<should be \>word 2\>&1>,

This will have false positives for things like the following:

  $as_echo "$as_me:${as_lineno-$LINENO}: error: $1" >&$3

That is, we should allow for the results of an expansion to be used for
“word” (according to SUS's[0] use of the term).

> If you allow me, attached is another mbox with two more patches. The
> archive-wide check is not done yet and I've only verified some of the
> results, but there doesn't seem to be any (major at least)
> bug/regression introduced by those changes. Some false positives are
> now visible because some portions of code are now actually checked,
> but that's it.

These changes introduces a false positive wrt here strings.

  possible bashism in src/auto/configure line 4650 (<<< here string):
             { $as_echo "$as_me:${as_lineno-$LINENO}: result: >>> Perl > 5.6 with 5.5 threads cannot be used <<<" >&5

On the plus isde, they fixed another false positive by properly handling
single-quoted strings that span multiple lines.

> They are both required to make checkbashisms actually find bashisms in
> complex scripts such as "configure" scripts.

Thanks,

[0]: http://www.opengroup.org/onlinepubs/9699919799/utilities/V3_chap02.html#tag_18_07_05
-- 
James
GPG Key: 1024D/61326D40 2003-09-02 James Vega <jamessan@debian.org>
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Devscripts Devel Team <pkg-devscripts@teams.debian.net>:
Bug#497489; Package devscripts. (Wed, 26 May 2010 16:09:03 GMT) Full text and rfc822 format available.

Message #48 received at 497489@bugs.debian.org (full text, mbox):

From: Raphael Geissert <geissert@debian.org>
To: 497489@bugs.debian.org
Subject: Re: Bug#497489: checkbashisms: multiple patches
Date: Wed, 26 May 2010 11:06:59 -0500
Hi James,

On Tuesday 25 May 2010 17:55:53 James Vega wrote:
> I noticed via one of your other patches what looks to be a bad check for file
> redirection.
> 
>   qr'(<\&|>\&)\s*((-|\d+)[^\s;|)}`&\\\\]|[^-\d\s]+)' =>
>                                  q<should be \>word 2\>&1>,
> 
> This will have false positives for things like the following:
> 
>   $as_echo "$as_me:${as_lineno-$LINENO}: error: $1" >&$3
> 
> That is, we should allow for the results of an expansion to be used for
> “word” (according to SUS's[0] use of the term).

The problem is that if $x doesn't contain a fd number then we would miss those 
cases. I think we could allow \$\d to hide the autoconf false positives.

> These changes introduces a false positive wrt here strings.
> 
>   possible bashism in src/auto/configure line 4650 (<<< here string):
>              { $as_echo "$as_me:${as_lineno-$LINENO}: result: >>> Perl >
> 5.6 with 5.5 threads cannot be used <<<" >&5

This one comes from the set of "it could already be triggered but the code was 
simply ignored." Running an old checkbashisms against that line produces the 
FP too.

But thanks, I've just added it to the testsuite.

The check for function names is now more likely to be more (FP-wise) visible 
on sed scripts too.

Cheers,
-- 
Raphael Geissert - Debian Developer
www.debian.org - get.debian.net




Reply sent to James Vega <jamessan@debian.org>:
You have taken responsibility. (Tue, 13 Jul 2010 03:36:03 GMT) Full text and rfc822 format available.

Notification sent to Raphael Geissert <atomo64@gmail.com>:
Bug acknowledged by developer. (Tue, 13 Jul 2010 03:36:03 GMT) Full text and rfc822 format available.

Message #53 received at 497489-close@bugs.debian.org (full text, mbox):

From: James Vega <jamessan@debian.org>
To: 497489-close@bugs.debian.org
Subject: Bug#497489: fixed in devscripts 2.10.65
Date: Tue, 13 Jul 2010 03:32:07 +0000
Source: devscripts
Source-Version: 2.10.65

We believe that the bug you reported is fixed in the latest version of
devscripts, which is due to be installed in the Debian FTP archive:

devscripts_2.10.65.dsc
  to main/d/devscripts/devscripts_2.10.65.dsc
devscripts_2.10.65.tar.gz
  to main/d/devscripts/devscripts_2.10.65.tar.gz
devscripts_2.10.65_i386.deb
  to main/d/devscripts/devscripts_2.10.65_i386.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 497489@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
James Vega <jamessan@debian.org> (supplier of updated devscripts package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: RIPEMD160

Format: 1.8
Date: Mon, 12 Jul 2010 23:22:08 -0400
Source: devscripts
Binary: devscripts
Architecture: source i386
Version: 2.10.65
Distribution: unstable
Urgency: low
Maintainer: Devscripts Devel Team <pkg-devscripts@teams.debian.net>
Changed-By: James Vega <jamessan@debian.org>
Description: 
 devscripts - scripts to make the life of a Debian Package maintainer easier
Closes: 497489 498898 530581 531327 535368 552693 563390 565889 572006 577564 577998 578118 578167 578334 580600 581224 583067 584734 584735 587217 587265 587517 588502 588714
Changes: 
 devscripts (2.10.65) unstable; urgency=low
 .
   [ James Vega ]
   * Remove mergechanges from the set of commands which use completion of
     package names.  (Closes: #578167)
   * bts:
     + Use sendmail to send mails with extra headers when $(DEB)EMAIL aren't
       present.  (Closes: #577564)
     + Document that $(DEB)EMAIL must be in the environment to send email using
       either --mutt or --smtp-host.  (Closes: #578334)
     + Cleanup the help output and add some options which were only documented
       in the man page.
     + Allow specifying multiple tag modifiers (+, -, =) in one tag stanza.
       (Closes: #578118)
     + Document the valid values for the status key in the select command.
       (Closes: #583067)
   * debsnap:
     + Iterate over the list of files listed for a hash until we find one that
       matches the requested package.  (Closes: #584734)
     + Warn and move on to the next file if no files are present for a given
       hash or none match the requested package.  (Closes: #587265)
     + Handle error responses from snapshot.debian.org.  (Closes: #587217)
     + Use the basename of the file being downloaded as the name under which to
       save it.  (Closes: #584735)
     + Do not remove the destination directory when --force is given.  (Closes:
       #587517)
   * Remove --ignore-dirname options (and deprecation notices) from all
     scripts.  6.5 years is long enough to stop using that option.
   * diff2patches: Document the patch naming scheme and use of “debian/” as the
     destination directory when “debian/patches/” doesn't exist.  (Closes:
     #552693)
   * mk-build-deps:
     + Add options to build packages which depend on solely Build-Depends or
       Build-Depends-Indep.  (Closes: #498898)
     + Include build-essential in Depends.  (Closes: #565889)
   * debi: Use “dpkg -O” instead of parsing dpkg-query's output to upgrade only
     packages which are already installed.  (Closes: #563390)
   * debcheckout: Specifically call out that Debian hosts are already handled
     in DEBCHECKOUT_AUTH_URLS' description.  Thanks to martin f. krafft for the
     suggested wording.  (Closes: #530581)
   * debchange: When running “dch -r”, use <dist>-backports if a backports
     upload is detected.  (Closes: #588502)
   * uupdate: Use “0ubuntu1” for the Debian revision of the version number when
     running uupdate on Ubuntu systems.  Based on a patch by Guillaume Martres.
     (Closes: #577998)
   * Ship French man pages in UTF-8 now that #196762 is fixed.
 .
   [ Martin Zobel-Helas ]
   * Remove svk from Recommends, it is no longer in the archive. (Closes:
     #581224)
 .
   [ Raphael Geissert ]
   * checkbashisms:
     + Makefile handling:
       - Simplify make variables as shell variables.  (Closes: #535368)
       - Convert all $$ to $.
       - Recognize SHELL setting in Makefile when being set as an override.
       - Ignore make's '-' for ignore errors.
       - Fix some false positives due to target names.
     + Detect incorrect use of ^ instead of ! for negation in pattern matching
       collections.  (Closes: #497489)
     + Detect use of {post,pre}{increment,decrement} in arithmetic expansion.
       (Closes: #572006)
     + Detect use of Bash's “printf -v var ...” or the %b and %q format
       specifiers.
     + Detect use of the Bash's “coproc” keyword.
     + Detect use of Bash's “;;&” and ”;&” operators.
     + Add support for handling line continuations.  (Closes: #531327)
     + Fix a false positive with file redirection.
     + Fix handling of indented heredoc delimiters.
     + Fix some parsing of quoted strings.
     + Detect use of exponentiation.
     + Detect use of the 'jobs' built-in.
     + Detect use of command with options other than “-p”.
     + Fix a false positive with redirection to an fd specified via a variable.
     + Detect unexpected EOF for unclosed heredocs, quoted strings, and line
       continuations.
 .
   [ Simon McVittie ]
   * mk-build-deps:
     + Build an Arch: any package if any of the Build-Depends have architecture
       requirements.  (Closes: #580600)
     + Allow specifying for which architecture to build the package.
 .
   [ Charles Plessy ]
   * debchange: Add “--team” support.  (Closes: #588714)
Checksums-Sha1: 
 7a5cef643ff4765dc78ddebd8bf8802ac81c37be 1443 devscripts_2.10.65.dsc
 540b4c2cbfcb66b11f0ef2b3dc92a91ffad59a85 694458 devscripts_2.10.65.tar.gz
 261b1a008f97f565b59f9456124101b23679195e 596490 devscripts_2.10.65_i386.deb
Checksums-Sha256: 
 73d71094e5f31c1cce5b0b973152393c27ddd59bb80024f9613179f3933ef24e 1443 devscripts_2.10.65.dsc
 be522f5f3aa505e7b7d9d47f8c6a61fc0e237d4329b2337b044344a21603d69c 694458 devscripts_2.10.65.tar.gz
 3a5c62ce42058c9674aa46769c1382951a9ca091162b7bf5350dc0f22f220629 596490 devscripts_2.10.65_i386.deb
Files: 
 20b6efe0127f91ec59ddf4fa5e444063 1443 devel optional devscripts_2.10.65.dsc
 6f8943b59841c8cb83db41c5c6f9918f 694458 devel optional devscripts_2.10.65.tar.gz
 ef79ab1e4f44baa88e737a1c563f6346 596490 devel optional devscripts_2.10.65_i386.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.10 (GNU/Linux)

iEYEAREDAAYFAkw73YIACgkQDb3UpmEybUD13QCgnQcZL4wdc7qAzeb1IEEg6y+V
p8sAnjhxcNtccj48HCDy82WGEu/WpaL5
=BgGK
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 11 Aug 2010 07:56:00 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Fri Apr 18 13:40:14 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.